'Projekt:	Ovladani ventilatoru aktivniho chlazeni
'Autor:	Pavel Skalicky
'Chip:	PICAXE 08M2+

'Definice symbolu a promenych

symbol HORNI 	= 130		;horni mez
symbol DOLNI 	= 69		;dolni mez
symbol ADCresult	= w0		;promenna pro vysledek AD prevod
symbol ADClast	= w1		;promenna pro ulozeni posledniho mereni
symbol ANA_IN	= 4		;analogovy vstup
symbol RED_LED	= 1		;pin pro cervenou LED
symbol ORANGE_LED	= 0		;pin pro oranzovu LED
symbol STRIDA	= w2		;promena pro ulozeni stridy PWM
symbol MAXHODNOTA	= 1024	;maximalni hodnota stridy
symbol ADCvzorek	= w3		;promena pro ulozeni vzorku PWM
;symbol KOREKCE 	= 67		;korekce pri mereni napeti, pouzito pouze pri
					;pouziti serioveho protu
symbol KOREKCE_OTACEK = 400	;snizeni otacek ventilatoru

'Inicializace pocatecnich hodnot promennych

low ORANGE_LED		;zasnuto
low RED_LED			;zhasnuto
;nastaveni vychozich hodnot pro mereni
ADClast	= 0
ADCresult	= 0


'Hlavni smycka
start:

	for b9 = 1 to 64					;nacteni 64 vzorku
		
		readadc10 ANA_IN,ADCvzorek		;zmeri napeti na pinu 4, ulozi do w0
		ADCresult = ADCresult + ADCvzorek	;ulozeni vzorku
		
	next b9
	
	ADCresult = ADCresult / 64			;zprumerovani vysledku
	STRIDA = MAXHODNOTA - ADCresult		;nastaveni periody
	STRIDA = STRIDA - KOREKCE_OTACEK		;snizeni otacek ventilatoru
	
	;tato cast kodu slouzi pro mereni pomoci serioveho portu
	;prepocitava a prevadi vysledek mereni AD prevodniku na textovy retezec
	;nasledne jej posle pres seriovy port do PC
	;w5 = ADCresult
	;w5 = w5*5+KOREKCE
	;w6 = w5/1000
	;w7 = w5//1000
	
	;sertxd("U = ",#w6,".")
	
	;if w7<10 then
	;	sertxd("0")
	;endif
	
	;if w7<100 then
	;	sertxd("0")
	;endif
	
	;sertxd(#w7," V",13,10)
	
	;vyhodnoceni mereni
	if ADCresult<>ADClast then
	
		if ADCresult<=HORNI then		;pokud je hodnota AD prevodu rovna
								;nebo nizsi nez horni hranice
			high ORANGE_LED			;rozsviti oranzovou LED
			pwmout 2,255,STRIDA		;rozbehne ventilator
			
			if ADCresult<=DOLNI then	;pokud je nizsi nez dolni hranice
			
				high RED_LED		;rozsviti cervenou LED
								;v zesilovaci nerealizovano
			else					;cervena LED nezapojena
								;mozno pouzit napr. pro vypnuti
				low RED_LED			;celeho systemu - ochrana pred 
								;prehratim apod.
			endif
		else
		
			low ORANGE_LED			;pokud je hodnota AD prevodu
			pwmout 2,255,0			;vyssi nez horni hranice
								;ventilator se netoci
		endif
		
		ADClast = ADCresult			;ulozeni posledniho vysledku
	endif
	
	ADCresult = 0					;znovu nastaveni pocatecni hodnoty
	
	pause 1000						;cekani 1s
	
goto start